<template>
  <AtomLoader
    v-if="pending"
    class="fr-mx-auto"
  />
  <AtomAlert
    v-else-if="error"
    :alert-type="AlertType.Error"
    message="Les statistiques de la répartion des départements ou services de l'administration centrale n'ont pas pu être chargées."
  />

  <StatsList
    v-if="ministereDepartementServiceAcStats.length"
    :total-count="beneficiaryCount"
    :stats="ministereDepartementServiceAcStats"
    stats-bar
    :not-filled-route="
      routes.beneficiary.AppBeneficiaries.path({
        notFilled:
          FilterBeneficiaryNotFilled.BeneficiaryMinistereDepartementServiceAc
      })
    "
  />
  <p v-else>
    Commencez à
    <NuxtLink :to="routes.beneficiary.AppBeneficiariesAdd.path()"
      >créer des fiches de bénéficiaires</NuxtLink
    >
    pour voir apparaître les statistiques de la répartition des départements ou
    services de l'administration centrale.
  </p>
</template>

<script setup lang="ts">
  import { AlertType } from '~/utils/constants/alert'
  import { routes } from '~/utils/routes'
  import { StatFilterInput } from '~/server/schema'
  import {
    ministereDepartmentServiceAcKeys,
    getStatLabel
  } from '~/client/options'
  import { FilterBeneficiaryNotFilled } from '~/utils/constants/filters'

  const props = defineProps<{
    beneficiaryCount: number
    filters: StatFilterInput
  }>()

  const {
    data: ministereDepartementServiceAcCounts,
    pending,
    error
  } = await useTrpcClient().stat.getMinistereDepartementServiceAc.useQuery(
    props.filters
  )

  const ministereDepartementServiceAcStats = computed(
    () =>
      ministereDepartementServiceAcCounts.value?.map(
        ({ _count, ministereDepartementServiceAc }) => ({
          key: ministereDepartementServiceAc || 'null',
          label: getStatLabel(
            ministereDepartmentServiceAcKeys.byKey,
            ministereDepartementServiceAc
          ),
          count: _count
        })
      ) || []
  )
</script>
